#version 460 core

layout(location = 0) in vec3 aPos;
layout(location = 1) in vec3 aNormal;
layout(location = 2) in vec2 aTexCoord;

out vec3 FragPos;
out vec3 Normal;
out vec2 TexCoord;
out vec3 OurColor;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform vec2 scrollOffset;
uniform bool flippedNormal;

void main()
{
    TexCoord = aTexCoord + scrollOffset;
    vec4 worldPos = model * vec4(aPos, 1.0);
    FragPos = worldPos.xyz;
    if (flippedNormal) {
        Normal = mat3(transpose(inverse(model))) * -aNormal;
    }
    else {
        Normal = mat3(transpose(inverse(model))) * aNormal;
    }
    
    gl_Position = projection * view * worldPos;
}
